' Faktura-Software Scriptdatei 
' Funktion: 	Belege in Mahnlauf aufnehmen
' Ansicht:  	FakturaBelege
' Script:	FakturaBelege_23_Belege_in_Mahnunglauf_kopieren.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->



'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "001"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "118"
sErrorSkript    = "023"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------


if WScript.RightClicked Then
  Dim sAnsicht
  sAnsicht = "FakturaMahnlauf"
  if CRM.CurrentProject.ActiveViews.ItemByName(sAnsicht) is nothing then
    'Ansicht neu ffnen
    cRM.CurrentProject.OpenNewViewByName(sAnsicht)
  else 
    'bestehende Ansicht aktivieren
    CRM.CurrentProject.ActiveViews.ItemByName(sAnsicht).Activate
   End if
   WScript.Quit
 End if


'----- 1. Mahnlauf auswhlen -----

' Ansicht Mahnlauf ffnen
Dim oViewConfigMahnlauf
Set oViewConfigMahnlauf = cRM.CurrentProject().ViewConfigs().ItemByName(CStr("FakturaMahnlauf"))

' Alle Datenstze der Ansicht Mahnlauf holen
Dim oRecordSetMahnlauf
Set oRecordSetMahnlauf = oViewConfigMahnlauf.CreateRecordSet

'Filter erstellen
Dim sFilter
sFilter = "(""Factura_Mahnlauf"".""Mahnlauf_Beendet"" = 0 OR ""Factura_Mahnlauf"".""Mahnlauf_Beendet"" IS NULL)"
oRecordSetMahnlauf.SetFilter(sFilter)

' berprfung, ob sich Datenstze im Filter befinden
If Not (oRecordSetMahnlauf.MoveFirst()) Then
	
	ShowMessage("Es wurde kein aktiver Mahnlauf gefunden. " & vbLf & "Bitte wechseln Sie in die Ansicht FakturaMahnlauf und legen Sie dort einen neuen Mahnlauf an." & vbLf & "Die Funktion wird beendet...")
	' Script beenden
	Set oRecordSetMahnlauf = Nothing
	Set oViewConfigMahnlauf = Nothing
	WScript.Quit
	
End If
	
' Benutzerauswahl des Mahnlaufs
Dim oRecordMahnlauf
Set oRecordMahnlauf = oRecordSetMahnlauf.DialogSelectRecord("Bitte whlen Sie den gewnschten Mahnlauf aus:")

' berprfung, ob ein Datensatz ausgewhlt wurde
If oRecordMahnlauf Is Nothing Then

	' Script beenden
	Set oRecordSetMahnlauf = Nothing
	Set oViewConfigMahnlauf = Nothing
	WScript.Quit
	
End If

' RecordID des ausgewhlten Mahnlaufs
Dim sMahnlaufID, sMahnlaufName
sMahnlaufID = oRecordMahnlauf.GetContentsByName(CStr("Recordid"))
sMahnlaufName = oRecordMahnlauf.GetContentsByName(CStr("Mahnlauf_Name"))


' Aktive Ansicht, hier Ansicht FakturaBelege
Dim oProject, oActiveView, oCurrentRecordSet
Set oActiveView = cRM.CurrentProject().ActiveViews().ActiveView

Dim oViewConfig
Set oViewConfig = oActiveView.Config

Dim oRelations
Set oRelations = oViewConfig.Relations

' Relation auf die Ansicht FakturaMahnlauf_Belege (Zurodnung)
Dim oRelation
Set oRelation = oRelations.ItemByName("Recordid.FakturaMahnlauf_Belege.Belege_Recordid")

' Alle Datenstze im Filter
Dim oRecordSet
Set oRecordSet = oActiveView.CurrentRecordSet()


'----------------Erweiterung 02.11.2010: Es werden nur Belege bertragen, deren Beleg_Summen ber dem Wert  'BelegeMahnenAbSumme' in Factura_Software_Global sind.

' --- Eweiterung 09.02.2012 (Patch 0027): Es werden zudem nur Belegtypen bertragen, die mahnfhig sind

dim sFilterMahnsumme,dMahnsumme,sFilterGlobal,iBelege,iMahnBelege

iBelege = oRecordSet.RecCount

'Mindestsumme fr mahnfhige Belege auslesen
sFilterGlobal = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMahnenAbSumme')"
'View, sFilter,sField, sErrorMsg
dMahnsumme = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen",sFilterGlobal,"Result","Die Mindestsumme fr Mahnungen konnte nicht gefunden werden")

if dMahnsumme = "" Then
  dMahnsumme = "0"
End If


dMahnsumme = cdbl(dMahnsumme) 
dMahnsumme = Stringreplace(dMahnsumme,".",",") 
dMahnsumme =FormatNumber(dMahnsumme,2,-1,0,-1)


      
sFilterMahnsumme = " select ""Factura_Belege"".""Recordid"" from ""Factura_Belege""" _
			   &" inner join ""v_Factura_Belege_Summe"" on ""Factura_Belege"".""Recordid""" _
			   &" = ""v_Factura_Belege_Summe"".""Belege_Recordid"" "_
			   & "inner join ""Factura_Beleg_Typen"" on ""Factura_Belege"".""Beleg_Typen_Recordid"" = ""Factura_Beleg_Typen"".""Recordid""" & vblf _
			   & "inner join ""Factura_Zahlungsarten"" on ""Factura_Belege"".""Zahlungsarten_Recordid"" = ""Factura_Zahlungsarten"".""Recordid""" & vblf _
			   &"where (""v_Factura_Belege_Summe"".""Netto_Beleg_Total"" > ("_
			   & " Select ""Factura_Software_Global"" .""Result"" from ""Factura_Software_Global"""_
			   & "where ""Factura_Software_Global"".""FS_Recordid"" ='BelegeMahnenAbSumme')) " & vblf _ 
			   & "AND ""Factura_Beleg_Typen"".""Beleg_Mahnung""= 1 " & vblf _
			   & "AND (""Factura_Zahlungsarten"".""Mahnlauf_Ignorieren"" is null or ""Factura_Zahlungsarten"".""Mahnlauf_Ignorieren"" = 0 )"

oRecordSet.SetFilterDirectSQL sFilterMahnsumme,true




' berprfung, ob sich Datenstze im Filter befinden
If Not (oRecordSet.MoveFirst()) Then
	
	showmessage("Es wurden keine Belege zum Mahnen gefunden. Ab einem Betrag von " & dMahnsumme & " kann gemahnt werden.")
	' Script beenden
	Set oRecordSetMahnlauf = Nothing
	Set oViewConfigMahnlauf = Nothing
	WScript.Quit
	
End If

Dim sMessage
iMahnbelege = oRecordset.RecCount


if cint(iBelege) > cint(iMahnbelege) then

  sMessage = " Es wurden " & iBelege& " Belege fr den Mahnlauf vorgesehen, von denen lediglich " & iMahnbelege & " Belege die Mindestsumme fr Mahnungen von " & dMahnsumme & " berschreiten und mahnfhig sind. Fortfahren mit dem Mahnlauf?"
ELSE

  sMessage = "Mchten Sie wirklich diese " & oRecordSet.RecCount & " Belege in den Mahnlauf  '" & sMahnlaufName & "' einfgen?"
END IF

' Sicherheitsabfrage
If MsgBox(sMessage, vbYesNo+vbQuestion, "Faktura Software fr den combit Relationship Manager") = vbYes Then

	' Relationales Ergnzen
	If (oRecordSet.RelationalAppendDirect(oRelation, CStr("Mahnlauf_Recordid=" & sMahnlaufID ))) Then
		
		MsgBox "Die Belege wurden erfolgreich zugeordnet.", vbInformation, "Faktura Software fr den combit Relationship Manager"
		
	Else
		
		RaiseException("ErrorCode:" & sErrorCode & "002" & vbLF & vbLF & "Der Mahnlauf konnte nicht zugeordnet werden. " & vbLF & "Das Script wird nicht fortgesetzt")
	End If
	
End If

' Objekte freigeben
Set oRecordSet       = Nothing
Set oRelation           = Nothing
Set oRelations = Nothing
Set oViewConfig = Nothing
Set oActiveView = Nothing
Set oRecordMahnlauf = Nothing
Set oRecordSetMahnlauf = Nothing
Set oViewConfigMahnlauf = Nothing
