'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: 	Beleg des Mahnlaufes sollen direkt via E-Mail versendet werden. (Bsp Abo-Lauf)
' Ansicht:  	FakturaMahnlauf
' Script:	FakturaMahnlauf_06_Druck_Einzelmahnung.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Dr. Frank Wietzel

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->

'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "002"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Update 10.07.2011 bei rechtklick Sprache ignorieren
'--------------------------------------------------------------------------------------------------------------
' Version 003 
' - 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "137"
sErrorSkript    = "006"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

'Loginuser ermitteln
Dim sErf_User, oCurrentRecordset, iAnzahl_Ds, bFrage

sErf_User = cRM.CurrentProject.CurrentUser


Dim oViewConfig
Set oViewConfig = cRM.CurrentProject.ViewConfigs.ItemByName(CStr("FakturaMahnlauf_Belege"))

Dim oRecordSet
Set oRecordSet = oViewConfig.CreateRecordSet

' Abfragen ob Mahnungen in mehrerern Sprachen verschickt werden sollen:
Dim sGlobalView, sGlobalField, sGlobalErrorMsg, sGlobalVariable, sGlobalFilter

sGlobalView 		= "FakturaGlobaleEinstellungen"
sGlobalFilter		= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'BelegeMailTextM_Multilang')"
sGlobalField		= "Result"
sGlobalErrorMsg		= "Fehler beim auslesen aus der Tabelle Factura_Software_Global :" & vbLf & sErrorCode & vbLf & "berprfen Sie ob der Eintrag <BelegeMailTextM_Multilang> in der Ansicht Factura_Software_Global vorhanden ist." & vbLf &vbLf & "Sollte dieser nicht vorhanden sein, so legen Sie diesen Datenastz (FS_Recordid) an." &vbLf &vbLf & "Bei Fragen knnen Sie sich gerne an den Support wenden." &vbLf

sGlobalVariable		= GetHiddenFieldContentByName(sGlobalView, sGlobalFilter,sGlobalField, sGlobalErrorMsg)  

Dim bMultilang


'-Update 10.07.2011 bei rechtklick Sprache ignorieren
If ((Ucase(sGlobalVariable)= Ucase("ja")) or (Ucase(sGlobalVariable)= Ucase("true"))) And Not WScript.RightClicked Then
 bMultilang = True
Else
 bMultilang = False
End If

Dim sSprache
if bMultilang Then
  sSprache = ShowInputbox("Geben Sie die gewnschte Sprache ein: " & vbLf &vbLf &" 1: Sprache 1 (Standardsprache)" &vbLf &" 2: Sprache 2" &vbLf &" 3: Sprache 3" &vbLf &" 4: Sprache 4" &vbLf,"1"  )
  If  (sSprache = "" )  or (NOt (IsNumeric(sSprache))) or (sSprache = " " ) Then
  	ShowMessage("FakturaMahnlauf_06_Druck_Einzelmahnung.vbs: " & sErrorCode & vbLf & vbLf & sSprache & " als Nr fr die Sprache ist nicht erlaubt oder die Funktion wurde abgebrochen. Die Funktion wird beendet." )
  	FunktionBeenden
  Else 
    if (sSprache > 4 )  then 
       'Showmessage("Der eingegebene Wert ist keiner Sprache zugeordnet. Der Vorgang wurde beendet.")
       ShowMessage("FakturaMahnlauf_06_Druck_Einzelmahnung.vbs: " & sErrorCode & vbLf & vbLf & sSprache & " als Nr fr die Sprache ist nicht erlaubt oder die Funktion wurde abgebrochen. Die Funktion wird beendet." )
       FunktionBeenden
    End if
  End If
  
Else 
  sSprache = "1"
End If

If sSprache = "1" Then
 sSprache = ""
Else
 sSprache = "S" & sSprache
End If


'CurrentRecordset von den Mahnungen
Dim sFilter

sFilter	= "1=1"

if not oRecordSet.SetFilter(sFilter) Then
  ShowMessage("FakturaMahnlauf_06_Druck_Einzelmahnung.vbs: " & sErrorCode & vbLf & vbLf & "Filter auf FakturaMahnlauf_Belege kann nicht ausgefhrt werden. Die Funktion wird beendet." )
  FunktionBeenden
End If


dim oinputform, sContainerName, oCurrentRecord, sRecordidMahnung
Set oinputform = cRM.CurrentProject.ActiveViews.ActiveView.CurrentInputForm(2)

sContainerName = "Recordid.FakturaMahnlauf_Belege.Mahnlauf_Recordid#{B6B73F48-CBC4-4B07-96C0-16F349CEBA20}"

Dim oContainers, oContainer

Set oContainers = oInputForm.Containers
Set oContainer = oContainers.ItemByName(sContainerName)

Set oCurrentRecord = oContainer.CurrentRecord

Dim sView, sFilter2,sField, sErrorMsg, spfad, sType 
'Reportdatei fr die Einzelmahnung finden
sView		= "FakturaGlobaleEinstellungen"
sFilter2	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'Mahnwesen_Druckvorlage_Einzeldruck" & sSprache &"')"
sField		= "Result"
sErrorMsg	= "Error Mahnlauf 005"


spfad =  GetHiddenFieldContentByName(sView, sFilter2,sField, sErrorMsg)  
spfad = ReplacePfad (sPfad)
'ShowMEssage(spfad)
'Dateityp
sType ="PRV"
'PrintSingelListinFile spfad,sType,
if WScript.RightClicked Then
  oCurrentRecord.PrintCard sType, spfad, false, ""
Else
	oCurrentRecord.PrintCard sType, spfad, true, ""
end if

'PrintSingelCardtoPdfnoMessage(sReportFilePath,sFile)





Function ReplacePfad (sString)

  Dim sPRJDIR,sAPPDIR,sUSERDIR,sTEMPDIR, sNewString

  sPRJDIR   = "%PRJDIR%"
  sAPPDIR   = "%APPDIR%"
  sUSERDIR = "%USERDIR%"
  sTEMPDIR = "%TEMPDIR%"
  
  if instr(sString,"%PRJDIR") > 0 Then
     sNewString  = StringReplace (sString, "%PRJDIR", sPRJDIR)
  End if
  
  if instr(sString,"%APPDIR") > 0 Then
     sNewString  = StringReplace (sString, "%APPDIR", sAPPDIR)
  End if
  
  if instr(sString,"%USERDIR") > 0 Then
     sNewString  = StringReplace (sString, "%USERDIR", sUSERDIR)
  End if
  
  if instr(sString,"%TEMPDIR") > 0 Then
     sNewString  = StringReplace (sString, "%TEMPDIR", sTEMPDIR)
  End if

  ReplacePfad= StringReplace (sNewString, "%", "") 

End Function





Sub FunktionBeenden()

  Set oCurrentRecordset = Nothing


Wscript.Quit

End Sub







